#include "common.ch"

MEMVAR _REQUEST

FUNCTION HRBMAIN()

LOCAL i , cTemp  , cRes := ''

	SET DATE FORMAT "yyyy-mm-dd"

	cRes := 'OK'

	cTable		:= _REQUEST[ "cDbf" ]
	aColumns	:= &(_REQUEST[ "aColumns" ])
	aValues		:= &(_REQUEST[ "aValues" ])

	cUser		:= _REQUEST[ "cUser" ]
	cPassword	:= _REQUEST[ "cPassword" ]

	* CHECK VALID USER ************************************************

	IF EMPTY(cUser) .OR. EMPTY(cPassword)
		RETURN 'ERROR (APPEND): INVALID ACCOUNT!'
	ENDIF
	USE ../DATA/USERS SHARED
	LOCATE FOR ALLTRIM(UPPER(USER)) == ALLTRIM(UPPER( cUser )) ;
		.AND. ;
		ALLTRIM(UPPER(PASSWORD)) == ALLTRIM(UPPER( cPassword )) 
		IF .NOT. FOUND()
			USE
			RETURN 'ERROR (APPEND): INVALID ACCOUNT!'
		ENDIF			
	USE

	* END CHECK VALID USER ********************************************

	* VALID FILE NAME *************************************************
	
	IF AT('\',cTable) <> 0 .OR. AT('/',cTable) <> 0
		RETURN 'ERROR (APPEND): INVALID FILE NAME'
	ENDIF

	* END VALID FILE NAME *********************************************

	USE ( '../DATA/' + cTable ) SHARED

		APPEND BLANK		

		FOR i := 1 TO LEN(aColumns)

			IF	TYPE( aColumns[i] ) = 'N'

				aValues[i] := VAL(aValues[i])

			ELSEIF	TYPE( aColumns[i] ) = 'L'

				aValues[i] :=  IF ( aValues [i] == 'Yes' , .T. , .F. )

			ELSEIF	TYPE( aColumns[i] ) = 'D'

				aValues[i] := CTOD(aValues[i])

			ENDIF

			REPLACE &(aColumns[i]) WITH aValues[i]

		NEXT i

	USE 

RETURN cRes
