#include "common.ch"

MEMVAR _REQUEST

FUNCTION HRBMAIN()

LOCAL i , cTemp  , cRes := ''

	SET DATE FORMAT "yyyy-mm-dd"

	cTable		:= _REQUEST[ "cDbf" ]
	aColumns	:= &(_REQUEST[ "aColumns" ])
	aValues		:= &(_REQUEST[ "aValues" ])
	cForExpr	:= _REQUEST[ "cForExpr" ]

	cUser		:= _REQUEST[ "cUser" ]
	cPassword	:= _REQUEST[ "cPassword" ]

	* CHECK VALID USER ************************************************

	IF EMPTY(cUser) .OR. EMPTY(cPassword)
		RETURN 'ERROR (MODIFY): INVALID ACCOUNT!'
	ENDIF
	USE ../DATA/USERS SHARED
	LOCATE FOR ALLTRIM(UPPER(USER)) == ALLTRIM(UPPER( cUser )) ;
		.AND. ;
		ALLTRIM(UPPER(PASSWORD)) == ALLTRIM(UPPER( cPassword )) 
		IF .NOT. FOUND()
			USE
			RETURN 'ERROR (MODIFY): INVALID ACCOUNT!'
		ENDIF			
	USE
	                                                                   
	* END CHECK VALID USER ********************************************

	* VALID FILE NAME *************************************************
	
	IF AT('\',cTable) <> 0 .OR. AT('/',cTable) <> 0
		RETURN 'ERROR (MODIFY): INVALID FILE NAME'
	ENDIF

	* END VALID FILE NAME *********************************************

	USE ( '../DATA/' + cTable ) SHARED

		nCount := 0		

		IF FLOCK()

			LOCATE FOR &cForExpr

			DO WHILE FOUND()

				FOR i := 1 TO LEN(aColumns)

					IF	TYPE( aColumns[i] ) = 'N'

						aValues[i] := VAL(aValues[i])

					ELSEIF	TYPE( aColumns[i] ) = 'L'

						aValues[i] :=  IF ( aValues [i] == 'Yes' , .T. , .F. )

					ELSEIF	TYPE( aColumns[i] ) = 'D'

						aValues[i] := CTOD(aValues[i])

					ENDIF

					REPLACE &(aColumns[i]) WITH aValues[i]

				NEXT i

				nCount++

				CONTINUE

			ENDDO
		
		ENDIF

	USE 

	cRes := ALLTRIM(STR(nCount))

RETURN cRes
